﻿package {
	import org.undeadcode.console.Color;
	import org.undeadcode.console.Console;
	
	public class Hud {
		//----------------------------------------------------------------------------------------------------
		// Constants
		//----------------------------------------------------------------------------------------------------
		
		private static const maxMsgFrames:uint = 37+42;
		
		private static const messages:Array = [
			"Se un matxote y enfrentate a tu destino...                         ",
			"Prueba otra tecla, ke'sta ta ataska...                             ",
			"\xAD\xAD\xADNo se que decir!!!                                              ",
			"\xAD\xAD\xADPeperrr!!!                                                      ",
			"No cambie, no cambieee, no cambieeeee...                           ",
			"Jaich!!!                                                           ",
			"Tito... Tito...                                                    ",
			"Se\xA4or X                                                            ",
			"Cuidado e...                                                       ",
			"Confiamos en ti e...                                               ",
			"Vine de Andorra...                                                 ",
			"\xAD\xAD\xADPozi!!!                                                         ",
			"\xA8Que este juego es malo? Es lo que tiene ser yo...                 ",
			"Java es un pesti\xA4o y C# es maravilloso...                          ",
			"Hacer juegos no es tan guay como parece desde fuera...             ",
			"\xA8Para qu\x82 perder el tiempo jugando a esto en vez de al WoW?        ",
			"\xAD\xAD\xADMuerte al lacayo!!!                                             ",
			"Al final Kenshin se muere de sidah, oh ke\xA8\xA8\xA8                       "
		];
		
		//----------------------------------------------------------------------------------------------------
		// Fields
		//----------------------------------------------------------------------------------------------------
		
		private var game:Game;
		
		private var msgTime:uint;
		
		private var msg:uint;
		
		//----------------------------------------------------------------------------------------------------
		// Public Methods
		//----------------------------------------------------------------------------------------------------
		
		public function Hud(g:Game) {
			this.game = g;
		}
		
		public function NewGame():void {
			this.msgTime = Hud.maxMsgFrames;
			this.msg = 0;
			this.drawPoints();
		}
		
		public function Frame():void {
			this.checkMsg();
			this.drawPoints();
		}
		
		public function DrawWrongKeyMsg():void {
			this.msgTime = 0;
			this.msg = 1;
			this.drawMsg();
		}
		
		public function DrawSuicideMsg():void {
			this.msgTime = 0;
			this.msg = 0;
			this.drawMsg();
		}
		
		//----------------------------------------------------------------------------------------------------
		// Private Methods
		//----------------------------------------------------------------------------------------------------
		
		private function checkMsg():void {
			this.msgTime++;
			if (this.msgTime > Hud.maxMsgFrames) {
				this.msgTime = 0;
				this.msg = Math.floor(16 * Math.random()) + 2;
				this.drawMsg();
			}
		}
		private function drawMsg():void {
			Game.System.TextColor = Color.BrightYellow;
			Game.System.BackColor = Color.Black;
			Game.System.GotoXY(0, 20);
			Game.System.PutString(Hud.messages[this.msg]);
		}
		
		private function drawPoints():void {
			Game.System.TextColor = Color.BrightYellow;
			Game.System.BackColor = Color.Black;
			Game.System.GotoXY(0, 21);
			Game.System.PutString("Puntuaci\xA2n: " + this.game.Points.toString());
		}
	}
}