﻿package {
	import flash.geom.Point;
	import org.undeadcode.console.Color;
	import org.undeadcode.console.Console;
	
	public class Maze {
		//----------------------------------------------------------------------------------------------------
		// Constants
		//----------------------------------------------------------------------------------------------------
		
		//----------------------------------------------------------------------------------------------------
		// Fields
		//----------------------------------------------------------------------------------------------------
		
		private var game:Game;
		
		private var numTomatoes:uint;
		
		private var tomatoes:Vector.<Point>;
		
		//----------------------------------------------------------------------------------------------------
		// Public Methods
		//----------------------------------------------------------------------------------------------------
		
		public function Maze(g:Game) {
			this.game = g;
		}
		
		public function NewGame():void {
			var i:uint, j:uint;
			
			Game.System.TextColor = Color.Black;
			Game.System.BackColor = Color.Red;
			
			Game.System.GotoXY(0, 0); Game.System.PutChar("\xC9");
			for(j = 1; j < 69; j++) {
				Game.System.GotoXY(j, 0); Game.System.PutChar("\xCD");
			}
			Game.System.GotoXY(69, 0); Game.System.PutChar("\xBB");


			for(i = 1; i < 19; i++) {
				Game.System.GotoXY(0, i); Game.System.PutChar("\xBA");
				Game.System.GotoXY(69, i); Game.System.PutChar("\xBA");
			}


			Game.System.GotoXY(0, 19); Game.System.PutChar("\xC8");
			for(j = 1; j < 69; j++) {
				Game.System.GotoXY(j, 19); Game.System.PutChar("\xCD");
			}
			Game.System.GotoXY(69, 19); Game.System.PutChar("\xBC");
			
			
			this.numTomatoes = 0;
			this.tomatoes = new Vector.<Point>();
		}
		
		public function Frame():void {
			this.clear();
			
			if (this.numTomatoes < 1) {
				this.addTomatoes();
			}
			this.drawTomatoes();
		}
		
		public function KillTomato(p:Point):void {
			var victim:int = this.getTomato(p);
			if (victim > -1) {
				this.tomatoes.splice(victim, 1);
				this.game.Points++;
				this.numTomatoes--;
			}
		}
		
		public function CollidesTomatoes(p:Point):Boolean {
			for each (var part:Point in this.tomatoes) {
				if (part.x == p.x && part.y == p.y) return true;
			}
			return false;
		}
		
		public function CollidesWalls(p:Point):Boolean {
			if (p.y <= 0 || p.y >= 19) return true;
			if (p.x <= 0 || p.x >= 69) return true;
			return false;
		}
		
		public function Collides(p:Point):Boolean {
			if (this.CollidesWalls(p)) {
				return true;
			} else {
				return this.CollidesTomatoes(p);
			}
		}
		
		//----------------------------------------------------------------------------------------------------
		// Private Methods
		//----------------------------------------------------------------------------------------------------
		
		private function clear():void {
			var i:uint, j:uint;
			
			Game.System.TextColor = Color.Black;
			Game.System.BackColor = Color.Black;
			
			for (i = 1; i < 19; i++) {
				for (j = 1; j < 69; j++) {
					Game.System.GotoXY(j, i);
					Game.System.PutChar(" ");
				}
			}
		}
		
		private function addTomatoes():void {
			var repeat:Boolean;
			var p:Point;
			
			for (var i:int = 0; i < 4; i++) {
				do {
					p = new Point();
					p.x = Math.floor(Math.random() * 68) + 1;
					p.y = Math.floor(Math.random() * 18) + 1;
					repeat = (this.Collides(p) || this.game.GetSnake().Collides(p));
				} while (repeat);
				this.tomatoes.push(p);
				this.numTomatoes++;
			}
		}
				
		public function getTomato(p:Point):int {
			for (var i:int = 0; i < this.tomatoes.length; i++) {
				if (this.tomatoes[i].x == p.x && this.tomatoes[i].y == p.y) return i;
			}
			return -1;
		}
		
		private function drawTomatoes():void {
			Game.System.TextColor = Color.Red;
			Game.System.BackColor = Color.Black;
			
			for each (var t:Point in this.tomatoes) {
				Game.System.GotoXY(t.x, t.y);
				Game.System.PutChar("O");
			}
		}
	}
}