﻿package org.undeadcode.console {
	import flash.geom.ColorTransform;
	
	public class Color {
		//----------------------------------------------------------------------------------------------------
		// Constants
		//----------------------------------------------------------------------------------------------------
		
		/*
		 * Default EGA 16-color palette
		 * (set up to match the standard CGA colors)
		 * Color                                   	rgbRGB 	Decimal
		 * 0  – Black                    (#000000) 	000000 	0
		 * 1  – Blue                     (#0000AA) 	000001 	1
		 * 2  – Green                    (#00AA00) 	000010 	2
		 * 3  – Cyan                     (#00AAAA) 	000011 	3
		 * 4  – Red                      (#AA0000) 	000100 	4
		 * 5  – Magenta                  (#AA00AA) 	000101 	5
		 * 6  – Brown                    (#AA5500) 	010100 	20
		 * 7  – White / Light gray       (#AAAAAA) 	000111 	7
		 * 8  – Dark gray / Bright black (#555555) 	111000 	56
		 * 9  – Bright blue              (#5555FF) 	111001 	57
		 * 10 – Bright green             (#55FF55) 	111010 	58
		 * 11 – Bright cyan              (#55FFFF) 	111011 	59
		 * 12 – Bright red               (#FF5555) 	111100 	60
		 * 13 – Bright magenta           (#FF55FF) 	111101 	61
		 * 14 – Bright yellow            (#FFFF55) 	111110 	62
		 * 15 – Bright white             (#FFFFFF) 	111111 	63
		 */
		
		public static const Black:uint = 0;
		public static const Blue:uint = 1;
		public static const Green:uint = 2;
		public static const Cyan:uint = 3;
		public static const Red:uint = 4;
		public static const Magenta:uint = 5;
		public static const Brown:uint = 6;
		public static const LightGray:uint = 7;
		public static const DarkGray:uint = 8;
		public static const BrightBlue:uint = 9;
		public static const BrightGreen:uint = 10;
		public static const BrightCyan:uint = 11;
		public static const BrightRed:uint = 12;
		public static const BrightMagenta:uint = 13;
		public static const BrightYellow:uint = 14;
		public static const White:uint = 15;
		
		public static const MaxColors:uint = 16;
		
		public static const ArgbValues:Array = [
			0x000000, 0x0000AA, 0x00AA00, 0x00AAAA, 0xAA0000, 0xAA00AA, 0xAA5500, 0xAAAAAA,
		    0x555555, 0x5555FF, 0x55FF55, 0x55FFFF, 0xFF5555, 0xFF55FF, 0xFFFF55, 0xFFFFFF
		];
		
		private static const a:Number = 0xAA / 0xFF;
		private static const b:Number = 0x55 / 0xFF;
		
		public static const Transforms:Array = [
			new ColorTransform(0, 0, 0), // 0x000000
			new ColorTransform(0, 0, a), // 0x0000AA
			new ColorTransform(0, a, 0), // 0x00AA00
			new ColorTransform(0, a, a), // 0x00AAAA
			new ColorTransform(a, 0, 0), // 0xAA0000
			new ColorTransform(a, 0, a), // 0xAA00AA
			new ColorTransform(a, b, 0), // 0xAA5500
			new ColorTransform(a, a, a), // 0xAAAAAA
			new ColorTransform(b, b, b), // 0x555555
			new ColorTransform(b, b, 1), // 0x5555FF
			new ColorTransform(b, 1, b), // 0x55FF55
			new ColorTransform(b, 1, 1), // 0x55FFFF
			new ColorTransform(1, b, b), // 0xFF5555
			new ColorTransform(1, b, 1), // 0xFF55FF
			new ColorTransform(1, 1, b), // 0xFFFF55
			new ColorTransform(1, 1, 1)  // 0xFFFFFF
		];
		
		//----------------------------------------------------------------------------------------------------
		// Private Methods
		//----------------------------------------------------------------------------------------------------
		
		public function Color() {
		}
	}
}